/*
 * Handles the About dialog.
 */

#include <PalmOS.h>

#include "flipMain.h"
#include "version.h"
#include "resdefs.h"

static Boolean AboutEventHandler(EventPtr event);
static void AboutFormInit(void);

struct FormInfo AboutFormInfo = {
	EventStealer:NULL,
	EventHandler:AboutEventHandler,
	InitForm:AboutFormInit,
	DeinitForm:NULL,
	UpdateForm:NULL,
};

/* Show the About dialog. */
extern void ShowAboutForm(void)
{
	FrmPopupForm(AboutForm);
}

static void AboutFormInit(void)
{
	FormType *form;

	form = FrmGetActiveForm();

	FrmNewLabel(&form, AboutFormVersionLabel, 
		    FLIP_VERSION, 20, 20, stdFont);
	FrmNewLabel(&form, AboutFormCopyrightLabel, 
		    FLIP_COPYRIGHT, 20, 40, stdFont);
}

static Boolean AboutEventHandler(EventPtr event)
{
	if (event->eType == ctlSelectEvent) {
		switch (event->data.ctlSelect.controlID) {
		case AboutFormOKButton:
			FrmReturnToForm(WordListForm);
			return true;
		}
	}

	return false;
}
